
User Interface - Bug #3631

SYSTEM-DIALOG FONT won't accept keyboard input in the selection lists

06/20/2018 01:32 PM - Hynek Cihlar
Description

History

#1 - 04/30/2019 05:16 PM - Greg Shah

- Assignee set to Alexei Kaigorodov

#2 - 05/08/2019 04:07 AM - Alexei Kaigorodov

- File bug3631-system-dialog-font.p added

A test file (attached) runs successfully under FWD (revision 11304).

Keyboard input is accepted, though after moving focus to the input field labelled "Font:".

So the bug description can be changed to:

SYSTEM-DIALOG FONT window does not set focus on "Font:" field, while it does when running on 4gl.

#3 - 05/09/2019 08:15 AM - Greg Shah

If you manually put focus into a selection list, does it accept keyboard input?

#4 - 05/09/2019 08:19 AM - Alexei Kaigorodov

If focus manually is pointed  into the selection list, keyboard input is possible.

#5 - 05/09/2019 08:30 AM - Greg Shah

Please work on the initial focus issue.  The dialog is implemented in com/goldencode/p2j/ui/client/gui/FontChooserGuiImpl.java and it is created in

ThinClient.chooseFont().

#6 - 05/16/2019 02:02 AM - Alexei Kaigorodov

The font chooser is implemented in the class FontChooserGuiImpl, field ComboBoxGuiImpl fontFaceCbx. But ComboBoxGuiImpl is not a Swing

class, and we cannot force it to grab the focus. It is unclear where to find creation of the corresponding Swing component, and how to make it to

request the focus.

#7 - 05/16/2019 04:12 AM - Hynek Cihlar

Alexei Kaigorodov wrote:
The font chooser is implemented in the class FontChooserGuiImpl, field ComboBoxGuiImpl fontFaceCbx. But ComboBoxGuiImpl is not a Swing

class, and we cannot force it to grab the focus. It is unclear where to find creation of the corresponding Swing component, and how to make it to

request the focus.

 

As you already figured out, the legacy widgets (i.e. subclasses of AbstractWidget) don't have direct mapping to the Swing components. We handle all

the drawing and UI flow ourselves. What Swing (or Web browser in case of Web client) provides to us is only a window component and its graphic

context.

For focus handling see AbstractContainer.setFocus and how the method is used. Also see UiUtils.getCurrentFocus() (and its overloads), this method

is often used during dispatching of input events.

#8 - 05/29/2019 09:24 AM - Alexei Kaigorodov

- File 11312.diff added

Fixed in branch secure/code/p2j_repo/p2j/active/3631a, revision 11312.

Diff file attached.

Please review.

#9 - 05/29/2019 11:36 AM - Hynek Cihlar

Alexei Kaigorodov wrote:

Fixed in branch secure/code/p2j_repo/p2j/active/3631a, revision 11312.

Diff file attached.

Please review.

 

Code review 3631a 11312.

The change is good. Only a small modification. Instead of requestFocus() on the combo box widget, call setFocus() on the FontChooserGuiImpl class

and pass in the combo box widget. We want to avoid requestFocus() in this case as it triggers legacy focus events.

#10 - 05/29/2019 10:19 PM - Alexei Kaigorodov

setFocus(fontFaceCbx); has no visible effect - focus is not set to the combobox.

#11 - 05/30/2019 03:55 AM - Hynek Cihlar

Alexei Kaigorodov wrote:
setFocus(fontFaceCbx); has no visible effect - focus is not set to the combobox.

 

I didn't give you a complete answer, sorry. You have to call setFocus() on the container to which the combo box belongs. So not directly to the frame,

but to its "content" container. getContentPane().setFocus(fontFaceCbx); will resolve the issue.

#12 - 05/30/2019 04:36 AM - Alexei Kaigorodov

Hynek Cihlar wrote:

I didn't give you a complete answer, sorry. You have to call setFocus() on the container to which the combo box belongs. So not directly to the

frame, but to its "content" container. getContentPane().setFocus(fontFaceCbx); will resolve the issue.

 

Done. Tested. Commited to secure/code/p2j_repo/p2j/active/3631a.

#13 - 06/03/2019 09:30 AM - Alexei Kaigorodov

Please review.

#14 - 06/03/2019 10:35 AM - Hynek Cihlar

Code review 3631a revision 11311.

The code changes are OK. The changed file is missing history entry.

#15 - 06/03/2019 11:37 AM - Alexei Kaigorodov

Description added. Commited to secure/code/p2j_repo/p2j/active/3631a rev 11314

#16 - 06/03/2019 11:58 AM - Hynek Cihlar

Alexei Kaigorodov wrote:

Description added. Commited to secure/code/p2j_repo/p2j/active/3631a rev 11314

 

Also please update the Copyright year.

#17 - 06/03/2019 12:24 PM - Alexei Kaigorodov

Updated.
#18 - 06/03/2019 12:51 PM - Hynek Cihlar

Code review 3631a. The changes are good, no regression testing is required.

#19 - 06/03/2019 03:01 PM - Greg Shah

I made a small edit to remove the reference to OE (it is a trademark) and instead I used the more generic "4GL".

#20 - 06/03/2019 04:58 PM - Greg Shah

Please go ahead and merge 3631a revision 11316 (this is with my changes) into the trunk.  Follow the instructions (in our Source Management

document) exactly.  If you have any questions, do not move ahead until we've discussed them.  If you understand the instructions, then you can go

ahead.

#21 - 06/04/2019 07:24 AM - Alexei Kaigorodov

I made a local branch which has revision 11311 (the same as trunk) and 5 small commits after that.

then I made bzr merge to get the changes from my branch back into the source repo (as it is said in the Source_Code_Management document,

chapter "How Branching Works", point 10). But instead of expected effect "11. the resulting change will go back into the trunk as a single revision,

even if you had 50 branch-specific commits", the reply was:

"Nothing to do."

what am I doing wrong?

#22 - 06/04/2019 07:36 AM - Hynek Cihlar

Alexei Kaigorodov wrote:

I made a local branch which has revision 11311 (the same as trunk) and 5 small commits after that.

then I made bzr merge to get the changes from my branch back into the source repo (as it is said in the Source_Code_Management document,

chapter "How Branching Works", point 10). But instead of expected effect "11. the resulting change will go back into the trunk as a single

revision, even if you had 50 branch-specific commits", the reply was:

"Nothing to do."

what am I doing wrong?

 

Are you trying to merge the task branch in trunk? If so, follow Merge Back and Commit to the Trunk.

#23 - 06/04/2019 09:36 AM - Alexei Kaigorodov

3631a was merged to trunk rev 11312 and was archived.

#24 - 06/04/2019 09:39 AM - Greg Shah

- Status changed from New to Closed

- % Done changed from 0 to 100

Files

bug3631-system-dialog-font.p 561 Bytes 05/08/2019 Alexei Kaigorodov

11312.diff 602 Bytes 05/29/2019 Alexei Kaigorodov
